unit stdFiles;

{$MESSAGE 't@Cėp샆jbg Ver2.1'}
interface
  uses
    Windows, SysUtils, Classes, ShellApi, Registry, ShlObj,
    Forms, Math;

type        TExecuteWaitFlag  = (wfNone,wfWaitInput,wfWaitFull,wfWaitLong);
type        TWaitLongCallBack = procedure(const Command:String;const WaitTimes:Cardinal;
                                  const ProcessInfo:TProcessInformation;var Cancel:Boolean);
type
  TCSIDLList = (
    csidlPrograms , // vOtH_
    csidlPersonal , // }ChLg
    csidlFavorites, // Cɓ
    csidlStartUp  , // X^[gAbv
    csidlRecent   , // ŋߎgt@C
    csidlSendTo   , // 
    csidlStartMenu, // X^[gj[
    csidlDeskTop  , // fXNgbvtH_
    csidlTemplates, // ev[g
    csidlAppData    // Application Data
  );
  function  EnumFile          (const Path:string;Attr:Integer;ResultFiles:TStrings;EraseExt:Boolean=False):Boolean;
  function  SaveToFiletxt     (const Path, AText: String): Boolean;
  function  UNCSaveToFiletxt  (const Path: String;AText: WideString): Boolean;
  function  LoadFromFiletxt   (const Path: String): String;
  function  UNCLoadFromFiletxt(const Path: String;var Unicode: Boolean): String;
  function  GetFileSize       (const FileName:TFileName):Int64;
  function  FindExecutable    (var Executable:String;const FileName:String): Cardinal;
  function  Shell             (const Path:String;const WindowState:Integer=SW_SHOW;Wait:Boolean=False): HINST;
  function  RunAs             (const Executable: String;const CommandLine:String='';const WindowState:Integer=SW_SHOW;
    const WaitFlag:TExecuteWaitFlag=wfNone;WaitLongCallBack:TWaitLongCallBack=nil):Boolean;
  function  SearchNear        (const FileName: String;TrueFilePath : Boolean = true): TFileName;
  procedure RegFileName       (const FileName: String;Path:TFileName); overload;
  function  RegFileName       (const FileName: String):TFileName; overload;
  function  Wait              (const WaitMilliSecond:Cardinal):Cardinal;
  function  ByteToMK          (const ByteSize: Int64;var g,m,k:Word):Word;
  function  GetSpecialDirPath (const CSIDL: TCSIDLList): String; overload;
  function  GetSpecialDirPath (const CSIDL: Cardinal): String; overload;

  function  SH_Copy           (const Handle:HWND;FromFile,ToFile:TFileName): Integer;
  function  SH_Move           (const Handle:HWND;FromFile,ToFile:TFileName): Integer;
  function  SH_Delete         (const Handle:HWND;FileName:TFileName): Integer;
  function  SH_Rename         (const Handle:HWND;OldFile:TFileName;NewFile:String): Integer;

var
  RunAsDefaultExeFile: String;
const
  RegKey          = 'Software\Common\Path';
  UNC_BigEndian   = $FEFF;
  UNC_LittleEndian= $FFFE;
  CSIDLList : array[TCSIDLList] of Cardinal = (
    CSIDL_PROGRAMS,
    CSIDL_PERSONAL,
    CSIDL_FAVORITES,
    CSIDL_STARTUP,
    CSIDL_RECENT,
    CSIDL_SENDTO,
    CSIDL_STARTMENU,
    CSIDL_DESKTOPDIRECTORY,
    CSIDL_TEMPLATES,
    CSIDL_APPDATA
  );
implementation

/////////////////////////
// @ꂫ@
/////////////////////////
// 1.0...EnumFile,SaaveToFiletxt,LoadFromFiletxt֐ǉ
// 1.1...Shell֐ǉ
// 1.2...SH_Copy,Move,Delete,Rename֐ǉ
// 1.3...SearchNear,RegFileName֐,RegFileName葱ǉShell֐ɓNIvVǉ
// 1.4...SearchNeardlύX
// 1.5...EnumFile֐Ɉǉ
// 1.6...RunAs,Wait֐ǉ
// 1.7...GetFileSize,ByteToMK֐ǉ
// 1.8...SH...̎l̊֐C
// 1.9...FindExecutable֐ǉARunAs@\ǉ
// 2.0...UNCLoadFromFiletxt,UNCSaveToFiletxt֐ǉ
// 2.1...GetSpecialDirPath֐ǉ


function EnumFile(const Path:string;Attr:Integer;ResultFiles:TStrings;EraseExt:Boolean=False):Boolean;
var
  sr: TSearchRec;
begin
  Result := False;
  with ResultFiles do begin
    if FindFirst(Path,Attr,sr) = 0 then begin
      try
        repeat
          Result := True;
          if EraseExt then
            ResultFiles.Add(ChangeFileExt(sr.Name,''))
          else
            ResultFiles.Add(sr.Name);
        until FindNext(sr) <> 0
      finally
        FindClose(sr);
      end;
    end;
  end;
end;

function SaveToFiletxt(const Path, AText: String): Boolean;
begin
  Result := True;
  with TStringList.Create do begin
    try
      Text := AText;
      try
        SaveToFile(Path);
      except
        Result := False;
      end;
    finally
      Free;
    end;
  end;
end;

function UNCSaveToFiletxt(const Path: String;AText: WideString): Boolean;
var
  fs      : TFileStream;
  BOM     : Word;
begin
  BOM := UNC_BigEndian;
  fs  := TFileStream.Create(Path, fmCreate);
  try
    fs.Write(BOM, SizeOf(Word));
    fs.Write(AText[1], Length(AText) * 2);
    Result  := true;
  finally
    fs.Free;
  end;
end;

function LoadFromFiletxt(const Path: String): String;
begin
  with TStringList.Create do begin
    try
      LoadFromFile(Path);
      Result := Text;
    finally
      Free;
    end;
  end;
end;

function UNCLoadFromFiletxt(const Path: String;var Unicode: Boolean): String;
var
  fs      : TFileStream;
  BOM     : Word;
  length  : Int64;
  n       : Integer;
  PText   : PChar;
  chr     : Char;
begin
  Unicode := false;
  fs      := TFileStream.Create(Path, fmOpenRead or fmShareDenyNone);
  try
    fs.Position := 0;
    length := fs.Size;
    if length > SizeOf(Word) then begin // Unicodet@Cǂݍݏ
      PText := AllocMem(length + 10);
      fs.Seek(0, soFromBeginning);
      if fs.Read(PText^, length) = length then begin
        BOM := Ord(PText[1]) + Ord(PText[2]) shl 8;
        if BOM = UNC_BigEndian then begin // rbOGfBAȂ΁AeWord2oCgւ
          n := 0;
          while n < length do begin
            chr             := (PText + n)^;
            (PText + n)^    := (PText + n + 1)^;
            (PText + n + 1)^:= chr;
            Inc(n, SizeOf(Word));
          end;
        end else if not BOM = UNC_LittleEndian then begin// ʂASCIIt@C
          Result:= LoadFromFiletxt(Path);
          exit;
        end; { if BOM = UNC_BigEndian... }
        Result  := WideCharToString(PWideChar(PText + 2)); // Ǎ
        Unicode := true;
      end; { if fs.Read(PText^, length) = length... }
    end; { if length > SizeOf(Word)... }
  finally
    FreeMem(PText);
    fs.Free;
  end;
end;

function GetFileSize(const FileName:TFileName):Int64;
  //------------------------------------------------------------------------------
  // t@CTCY擾
  // FileNamect@C
  // ߂lct@CTCY(oCgP)@
  //------------------------------------------------------------------------------
var
  Handle: THandle;
  LSize,HSize : Cardinal;
begin
  Handle  := FileOpen(FileName, fmOpenRead or fmShareDenyWrite);
  // t@CJȂ
  if Handle <= 0 then
    raise Exception.Create('t@CJ܂');
  try
    LSize:= windows.GetFileSize(Handle, @HSize);
    // 32rbg
    Result := LSize + (HSize shl 32);
  finally
    FileClose(Handle);
  end;
end;

function FindExecutable(var Executable:String;const FileName:String): Cardinal;
  //------------------------------------------------------------------------------
  // gqɊ֘Atꂽt@C擾
  // Executablecs\t@C̃pXϐ
  // FileNamec֘AtTt@C
  // ߂lcFindExecutable̖߂lA펞32ȏ
  //  ߂lł͐łAFindExecutableAPIُȕԂƂ悤łB
  //    ̏ꍇÅ֐́Ǎʂ𖳎āAExecutableϐ̂܂ܕԂ܂B
  //------------------------------------------------------------------------------
var
  Path  : array[0..MAX_PATH] of Char;
begin
  Result := ShellApi.FindExecutable(PChar(FileName),nil,Path);
  if FileExists(Path) then
    Executable  := Path;
end;

function Shell(const Path:String;const WindowState:Integer=SW_SHOW;Wait:Boolean=false): HINST;
begin
  if Wait then
    Result  := HINST(RunAs(Path,'',WindowState,wfWaitFull))
  else
    Result  := ShellExecute(0,PChar('open'),PChar(Path),nil,nil,WindowState);
end;

function RunAs(const Executable: String;const CommandLine:String='';const WindowState:Integer=SW_SHOW;const WaitFlag:TExecuteWaitFlag=wfNone;WaitLongCallBack:TWaitLongCallBack=nil):Boolean;
  //------------------------------------------------------------------------------
  // st@CN
  // Executablecs\t@CpX
  // CommandLinecst@CɑR}hC
  // WindowStatecNAvP[V̕\`
  // WaitFlagcN҂tO
  //    wfNonecN҂ɏԂ
  //    wfInputcN܂ő҂
  //    wfFullcI܂ő҂(NԂZ\tgp)
  //    wfLongcI܂ő҂A1bƂWaitLongCallBackCxg
  //   WaitLongCallBackcTWaitLongCallBack^ACxgQƂ̃pubNϐ
  //  @CommandcCreateProcessAPIɑꂽR}h
  //    WaitTimesc܂ő҂
  //    ProcessInfocN\tg̃vZX
  //    CancelcLZtOAtrueɂƁA҂~ďԂB
  //------------------------------------------------------------------------------
var
  Path      : String;
  si        : TStartupInfo;
  pi        : TProcessInformation;
  roop,times: Cardinal;
  cancel    : Boolean;
begin
  Result  := false;
  Path    := Executable;
  if CommandLine <> '' then
    Path  := Path + ' ' + CommandLine;
  // N
  GetStartupInfo(si);
  if not CreateProcess(nil,PChar(Path),nil,nil,false,CREATE_DEFAULT_ERROR_MODE,nil,nil,si,pi) then
    // NɎs
    exit;
  // tOɂđ҂
  case WaitFlag of
    wfWaitInput :WaitForInputIdle(pi.hProcess,INFINITE);
    wfWaitFull  :WaitForSingleObject(pi.hProcess,INFINITE);
    wfWaitLong  :begin
      times := GetTickCount;
      cancel:= false;
      repeat
        roop := WaitForSingleObject(pi.hProcess, 1000);
        if Assigned(WaitLongCallBack) then
          WaitLongCallBack(Path,GetTickCount - times,pi,cancel);
        if cancel then break;
        Application.ProcessMessages;
      until roop = WAIT_OBJECT_0;
    end;
  end;
  // nhj
  CloseHandle(pi.hThread);
  CloseHandle(pi.hProcess);
  Result  := True;
end;

function SearchNear(const FileName: String;TrueFilePath : Boolean = true): TFileName;
var
  l       : Integer;
  Path,Dir: String;
  pc      : PChar;
begin
  New(pc);
  if not TrueFilePath then begin
    Path := RegFileName(FileName); // WXg擾
    if Path = '' then begin // ЂƂ̃tH_ɑ݂邩
      Dir := ExtractFileDir(ExcludeTrailingPathDelimiter(
        ExtractFileDir(Application.ExeName))) + '\';
      if FileExists(Dir + FileName) then
        Path := Dir + FileName;
    end;
    if Path = '' then begin // ЂƂ̃tH_ɑ݂邩
      Dir := ExtractFileDir(Application.ExeName) + '\' +
        ChangeFileExt(FileName,'') + '\';
      if FileExists(Dir + FileName) then
        Path := Dir + FileName;
    end;
  end;
  if Path = '' then begin // WpX擾
    SetLength(Path,MAX_PATH);
    l := SearchPath(nil,PChar(FileName),nil,MAX_PATH,PChar(Path),pc);
    SetLength(Path,l);
  end;
  Result:= Path;
  Dispose(pc);
end;

procedure RegFileName(const FileName: String;Path:TFileName);
  //------------------------------------------------------------------------------
  // WXg̃pẌɁAt@CpXۑ
  // FileNamect@CAL[ɂȂ
  // Pathct@CpX
  //------------------------------------------------------------------------------
begin
  // WXgɂ̃pXݒ
  if not FileExists(Path) then exit;
  with TRegistry.Create do begin
    try
      if OpenKey(RegKey,True) then begin
        WriteString(FileName,Path);
        CloseKey;
      end;
    finally
      Free;
    end;
  end;
end;

function RegFileName(const FileName: String): TFileName;
var s:String;
begin
  // WXg̃pX擾
  with TRegistry.Create do begin
    try
      if OpenKey(RegKey,True) then begin
         s := ReadString(FileName);
        if FileExists(s) then
          Result := s;
        CloseKey;
      end;
    finally
      Free;
    end;
  end;
end;

function Wait(const WaitMillisecond: Cardinal): Cardinal;
  //------------------------------------------------------------------------------
  // EFCgA̓Iɂ͋ۂ̃[v܂킷
  // WaitMillisecondc҂ׂ~b
  // Resultcۂɑ҂~b
  //------------------------------------------------------------------------------
var ms:Cardinal;
begin
  ms := GetTickCount;
  repeat
    Application.ProcessMessages;
  until ms + WaitMillisecond >= GetTickCount;
  Result := GetTickCount - ms;
end;

function ByteToMK(const ByteSize:Int64;var g,m,k:Word): Word;
  //------------------------------------------------------------------------------
  // oCgTCYAL,K,MKɕ
  // ByteSizecoCgTCY
  // gcMK̐lϐ
  // mcK̐lϐ
  // kcL̐lϐ
  // ߂lccoCgTCY
  //------------------------------------------------------------------------------
var restsize:Int64;
const onceSize=1024;
begin
  restsize := ByteSize;
  // MKZo
  g := Trunc(restSize / onceSize / onceSize / onceSize);
  restsize := restSize - g * (onceSize * 3);
  // KZo
  m := Trunc(restSize / onceSize / onceSize);
  restsize := restSize - m * (onceSize * 2);
  // LZo
  k := Trunc(restSize / onceSize);
  Result := restSize - k * onceSize;
end;

function GetSpecialDirPath(const CSIDL: TCSIDLList): String;
begin
  Result := GetSpecialDirPath(CSIDLList[CSIDL]);
end;

function GetSpecialDirPath(const CSIDL: Cardinal): String;
var
  IDList  : PItemIDList;
  Path    : array[0..MAX_PATH] of Char;
begin
  if Succeeded(SHGetSpecialFolderLocation(GetForegroundWindow, CSIDL, IDList)) then begin
    SHGetPathFromIDList(IDList, Path);
    Result := IncludeTrailingPathDelimiter(Path);
  end;
end;

function SH_Copy (const Handle:HWND;FromFile,ToFile:TFileName): Integer;
var fs:SHFILEOPSTRUCT;
begin
  with fs do begin
    Wnd   := Handle;
    pFrom := PChar(FromFile + #0#0);
    pTo   := PChar(ToFile + #0#0);
    wFunc := FO_COPY;
    fFlags:= FOF_ALLOWUNDO;
  end;
  Result := SHFileOperation(fs);
end;

function SH_Move (const Handle:HWND;FromFile,ToFile:TFileName): Integer;
var fs:SHFILEOPSTRUCT;
begin
  with fs do begin
    Wnd   := Handle;
    pFrom := PChar(FromFile + #0#0);
    pTo   := PChar(ToFile + #0#0);
    wFunc := FO_MOVE;
    fFlags:= FOF_ALLOWUNDO;
  end;
  Result := SHFileOperation(fs);
end;

function SH_Delete (const Handle:HWND;FileName:TFileName): Integer;
var fs:SHFILEOPSTRUCT;
begin
  with fs do begin
    Wnd   := Handle;
    pFrom := PChar(FileName + #0#0);
    pTo   := PChar(#0);
    wFunc := FO_DELETE;
    fFlags:= FOF_ALLOWUNDO;
  end;
  Result := SHFileOperation(fs);
end;

function SH_Rename (const Handle:HWND;OldFile:TFileName;NewFile:String): Integer;
var fs:SHFILEOPSTRUCT;
begin
  with fs do begin
    Wnd   := Handle;
    pFrom := PChar(OldFile + #0#0);
    pTo   := PChar(IncludeTrailingPathDelimiter(ExtractFilePath(OldFile)) + NewFile + #0#0);
    wFunc := FO_RENAME;
    fFlags:= FOF_ALLOWUNDO;
  end;
  Result := SHFileOperation(fs);
end;

initialization
  RunAsDefaultExeFile := '';
end.
