unit stdStrings;

{$MESSAGE 'ėp샆jbg Ver2.3'}
{$WARNINGS OFF}
interface
uses
  SysUtils, Classes, Math, StrUtils;
type        TEncType          = set of
  (encIniSection,encCommaText,encHTMLPage,encTabSpace);
  function  Strings           (Count:Cardinal;Value:String):String; deprecated;

  function  CharCount         (Text:String): Cardinal;
  function  Join              (const JoinArray:array of String;Delimiter:String=''):String;
  procedure AddStringsHist    (Strings:TStrings;const Str:String;const IgnoreStrs:array of String;const TopOfNew:Boolean=False;LimitedText:Cardinal= 0);
  procedure ArrayToStringList (const SourceArray:array of String;Results:TStrings);
  function  IncludeStr        (const Str:String;IgnoreCase:Boolean;TestString:array of string): Boolean;
  function  StringsReplace    (const Str:String;FindString,ReplaceString:array of string;ReplaceFlags:TReplaceFlags;Default:String=''): String;

  function  StringEncode      (const EncodeString:String;EncType:TEncType): String;
  function  StringsEncode     (const EncodeStrings:TStrings;EncType:TEncType): String;
  function  StringDecode      (const DecodeString:String;EncType:TEncType): String;
  function  StringsDecode     (const DecodeStrings:TStrings;EncType:TEncType): String;

  procedure ads               (var X: String;AddString:String);
  procedure adsln             (var X: String;AddString:String);

  function  StringsFormat     (const FormatStrings:TStrings;CenterString:String): String;

  function  ifor              (BaseVar:String;ParamVars:array of String): Boolean; overload;

  function  LikeStr           (const AText, Match: String; IgnoreCase: Boolean = false): Boolean;
  function  StartWith         (const AText, StartText: String; IgnoreCase: Boolean = false): Boolean;
  function  EndWith           (const AText, EndText: String; IgnoreCase: Boolean = false): Boolean;

implementation

/////////////////////////
// @ꂫ@
/////////////////////////
// 1.0...DelNull,Strings,Join֐ǉ
// 1.1...NewItems,NewItemsCount֐ǉ
// 1.2...ArrayToStringList֐ǉADelNull֐p~
// 1.3...NewItems,NewItemsCount֐AstdMenuItemɈړB
// 1.4...StringEndode,StringsEncode,StringDecode,StringsDecode֐ǉ
// 1.5...AddStringsHist葱ǉ
// 1.6...Ads֐ǉ,StringsEncode,StringsDecodeC
// 1.7...Adsln֐ǉ
// 1.8...AddStringsHist葱@\ǉ
// 1.9...StringEncode֐C
// 2.0...iforłړ
// 2.1...IncludeStr,StringsReplace֐ǉ
// 2.2...StringsFormat֐ǉ
// 2.3...StringsReplace֐ɁAȗǉ
// 2.4...ꕔ֐ɁA񐄏}[NtBLikeStr, StartWith, EndWith֐ǉ

////////////////////////////////////////////////////////////////////////////////
// 񐄏֐
////////////////////////////////////////////////////////////////////////////////

function Strings(Count:Cardinal;Value:String):String;
var i:Cardinal;
begin
  Result := '';
  for i := 1 to Count do
    Result := Result + Value;
end;

////////////////////////////////////////////////////////////////////////////////
// ʏ֐
////////////////////////////////////////////////////////////////////////////////

function CharCount(Text:String): Cardinal;
var Str:WideString;
begin
  Str := Text;
  Result:= Length(Str);
end;

function Join(const JoinArray: array of String;
  Delimiter: String = ''):String;
var
  i:Integer;
begin
  Result := '';
  for i := 0 to High(JoinArray) do
    if High(JoinArray) = i then
      Result := Result + JoinArray[i]
    else
      Result := Result + JoinArray[i] + Delimiter;
end;

procedure AddStringsHist(Strings: TStrings;
  const Str: String; const IgnoreStrs: array of String;
  const TopOfNew: Boolean = False;
  LimitedText: Cardinal = 0);
var i : Integer;
begin
  if ifor(Str,ignoreStrs) then exit;
  with Strings do begin
    i := IndexOf(Str);
    if i = - 1 then // ǉ
      Add(Str)
    else if TopOfNew then // ̂ړ
      Move(i,0);
    if (LimitedText = 0) and (Count > LimitedText) then
      // ~bg1ȏォ~bgɒBĂAȏ̂̂폜
      while (Count <= LimitedText) do begin
        Delete(Count - 1);
      end;
  end;
end;

procedure ArrayToStringList(const SourceArray:array of String;Results:TStrings);
var
  i:Cardinal;
begin
  for i := 0 to High(SourceArray) do
    Results.Add(SourceArray[i]);
end;


function StringEncode(const EncodeString:String;EncType:TEncType): String;
begin
  Result := EncodeString;
  if (encHTMLPage in EncType) then
    Result := StringReplace(StringReplace(StringReplace(StringReplace(
      Result,'&','&amp;',[rfReplaceAll]),
      '<','&lt;',[rfReplaceAll]),
      '>','&gt;',[rfReplaceAll]),
      '"','&quot;',[rfReplaceAll]);
  if (encIniSection in EncType) then
    Result := StringReplace(StringReplace(
      Result,'[','&scl;',[rfReplaceAll]),
      ']','&scg;',[rfReplaceAll]);
  if (encCommaText in EncType) then
    Result := StringReplace(Result,'"','&quot;',[rfReplaceAll]);
  if (encTabSpace in EncType) then
    Result := StringReplace(StringReplace(StringReplace(
      Result,#13#10,'\n',[rfReplaceAll]),
      #9,'\t',[rfReplaceAll]),
      #0,'\l',[rfReplaceAll]);
end;

function StringsEncode(const EncodeStrings:TStrings;EncType:TEncType): String;
var
  i : Integer;
  tp: TStringList;
begin
  tp := TStringList.Create;
  tp.Assign(EncodeStrings);
  with tp do
    for i := 0 to Count - 1 do
      Strings[i] := StringEncode(Strings[i],EncType);
  Result := tp.CommaText;
  tp.Free;
end;

function StringDecode(const DecodeString:String;EncType:TEncType): String;
begin
  Result := DecodeString;
  if (encIniSection in EncType) then
    Result := StringReplace(StringReplace(
      Result,'&scl;','[',[rfReplaceAll]),
      '&scg;',']',[rfReplaceAll]);
  if (encCommaText in EncType) then
    Result := StringReplace(Result,'&quot;','"',[rfReplaceAll]);
  if (encHTMLPage in EncType) then
    Result := StringReplace(StringReplace(StringReplace(StringReplace(
      Result,'&amp;','&',[rfReplaceAll]),
      '&lt;','<',[rfReplaceAll]),
      '&gt;','>',[rfReplaceAll]),
      '&quot;','"',[rfReplaceAll]);
  if (encTabSpace in EncType) then
    Result := StringReplace(StringReplace(StringReplace(
      Result,'\n',#13#10,[rfReplaceAll]),
      '\t',#9,[rfReplaceAll]),
      '\l',#0,[rfReplaceAll]);
end;

function StringsDecode(const DecodeStrings:TStrings;EncType:TEncType): String;
var
  i : Integer;
  tp: TStringList;
begin
  tp := TStringList.Create;
  tp.Assign(DecodeStrings);
  with tp do
    for i := 0 to Count - 1 do
      Strings[i] := StringDecode(Strings[i],EncType);
  Result := tp.CommaText;
  tp.Free;
end;

function StringsFormat(const FormatStrings:TStrings;CenterString:String): String;
  //------------------------------------------------------------------------------
  // Aw蕶܂ł̒ɂȂ悤ɐ`
  // FormatStringsc`TStrings
  // CenterStringcƂȂw蕶
  // ߂lc`ꂽCommaText
  //------------------------------------------------------------------------------
var
  Str       : TStringList;
  i,l,
    longest : Integer;
  s         : String;
begin
  Str := TStringList.Create;
  longest := 0;
  try
    //// ܂łԒs
    for i := 0 to FormatStrings.Count - 1 do begin
      l := Pos(CenterString,FormatStrings[i]);
      longest := Max(l,longest);
    end;
    //// ʒu킹
    for i := 0 to FormatStrings.Count - 1 do begin
      l := Pos(CenterString,FormatStrings[i]);
      s := FormatStrings[i];
      if InRange(l,1,longest - 1) then
        s := Copy(s,0,l - 1) + Strings(longest - l,' ') + Copy(s,l,9999);
      Str.Add(s);
    end;
    Result := Str.CommaText;
  finally
    Str.Free;
  end;
end;

procedure Ads(var X: String;AddString:String);
begin
  X := X + AddString;
end;

procedure Adsln(var X: String;AddString:String);
begin
  ads(X,AddString + #13#10);
end;

function ifor(BaseVar:String;ParamVars:array of String): Boolean; overload;
var i : Integer;
begin
  Result := False;
  for i := 0 to High(ParamVars) do
    if BaseVar = ParamVars[i] then begin
      Result := True;
      break;
    end;
end;

function  IncludeStr(const Str:String;IgnoreCase:Boolean;TestString:array of string): Boolean;
  //------------------------------------------------------------------------------
  // StrTestStringŝꂩ܂ނǂԂ
  // Strc
  // IgnoreCasecTrueɂƁA啶ʂȂ
  // TestStringsc
  // ߂lĉꂩ܂܂ĂTrueAȂFalse
  //------------------------------------------------------------------------------
var
  i   : Integer;
begin
  Result := false;
  for i := Low(TestString) to High(TestString) do begin
    if IgnoreCase then
      Result := AnsiContainsText(Str, TestString[i])
    else
      Result := AnsiContainsStr(Str, TestString[i]);
    if Result then Break;
  end;
end;

function StringsReplace(const Str:String;FindString,ReplaceString:array of string;ReplaceFlags:TReplaceFlags;Default:String=''): String;
  //------------------------------------------------------------------------------
  // ̕̕u
  // Strcu
  // FindStringc镔
  // ReplaceStringcu镔
  //    FindStringƌAȂꍇDefault̒lg
  // ReplaceFlagscutOAStringReplaceƓ
  // DefaultcReplaceStringz񂪁AFindStringZƂA
  //    Ȃ̒uƂ镶(ȗ'')
  //------------------------------------------------------------------------------
var
  i,l : Integer;
  rs  : String;
begin
  rs := Str;
  l := High(ReplaceString) - Low(ReplaceString);
  for i := Low(FindString) to High(FindString) do
    if i > l then
      rs := StringReplace(rs,FindString[i], Default,ReplaceFlags)
    else
      rs := StringReplace(rs,FindString[i], ReplaceString[i],ReplaceFlags);
  Result := rs;
end;

function  LikeStr(const AText, Match: String; IgnoreCase: Boolean): Boolean;
  //------------------------------------------------------------------------------
  // ChJ[hɂ}b`s
  // nPop̃\[XR[h
  // ATextc팟
  // Matchcp
  // ߂lc}b`True
  // ------
  // ChJ[h@
  // *cCӂ0ȏ̕
  // ?cCӂ1
  //------------------------------------------------------------------------------
var m, t: String;
  function _MatchString(ATextIndex, MatchIndex : Integer): Boolean;
  begin
    case m[MatchIndex] of
      #0  : // [
        Result := t[ATextIndex] = #0;
      '*' : // L}b`
        Result :=
          _MatchString(ATextIndex, MatchIndex + 1) or
          ((t[ATextIndex] <> #0) and
          _MatchString(ATextIndex + 1, MatchIndex));
      '?' : // ꕶ}b`
        Result :=
          (t[ATextIndex] <> #0) and
          _MatchString(ATextIndex + 1, MatchIndex + 1);
      else // ̂ق
        Result :=
          (t[ATextIndex] = m[MatchIndex]) and
          _MatchString(ATextIndex + 1, MatchIndex + 1);
    end;
  end;
  function lC(Str: String): String;
  begin
    if IgnoreCase then Result := AnsiLowerCase(Str) else Result := Str;
  end;
begin
  if AText = '' then
    // ATextɋ󕶎w肳ꂽ(*''̏ꍇ̂݃}b`)
    Result := (Match = '') or (Match = '*')
  else begin
    // ċA
    t := lC(AText);
    m := lC(Match);
    Result :=_MatchString(1, 1);
  end;
end;

function  StartWith(const AText, StartText: String; IgnoreCase: Boolean): Boolean;
  //------------------------------------------------------------------------------
  // C#StartWithB
  // ATextc팟
  // StartTextcp
  // IgnoreCasec啶𖳎
  // ߂lc}b`True
  //------------------------------------------------------------------------------
  function lC(Str: String): String;
  begin
    if IgnoreCase then Result := AnsiLowerCase(Str) else Result := Str;
  end;
begin
  Result := LeftStr(lC(AText), length(StartText)) = lC(StartText)
end;

function  EndWith(const AText, EndText: String; IgnoreCase: Boolean): Boolean;
  //------------------------------------------------------------------------------
  // C#EndWithB
  // ATextc팟
  // EndTextcp
  // IgnoreCasec啶𖳎
  // ߂lc}b`True
  //------------------------------------------------------------------------------
  function lC(Str: String): String;
  begin
    if IgnoreCase then Result := AnsiLowerCase(Str) else Result := Str;
  end;
begin
  Result := RightStr(lC(AText), length(EndText)) = lC(EndText);
end;


end.
